/* 	Copyright (c) 1993 NeXT Computer, Inc.  All rights reserved. 
 *
 * IODirectDevice class description.
 *
 * HISTORY
 * 08-Jan-93    Doug Mitchell at NeXT
 *      Created. 
 */

#import <driverkit/IODevice.h>

@interface IODirectDevice : IODevice
{
@private
	IODeviceDescription	*_deviceDescription;
	port_t			_interruptPort;
	void *			_ioThread;
	void *			_archPriv;
	int			_IODirectDevice_reserved[4];
}

/*
 * By defintion, all subclasses of this class are of style IO_DirectDevice.
 * Subclasses need not implement this method.
 */
+ (IODeviceStyle)deviceStyle;

- init;
- free;
- deviceDescription;
- (void)setDeviceDescription:deviceDescription;
- (port_t)interruptPort;
- (IOReturn)attachInterruptPort;
- (IOReturn)startIOThread;
- (IOReturn)startIOThreadWithPriority:(int)priority;
- (IOReturn)startIOThreadWithFixedPriority:(int)priority;
- (IOReturn)waitForInterrupt:(int *)id;
- (void)receiveMsg;
- (void)timeoutOccurred;
- (void)commandRequestOccurred;
- (void)interruptOccurred;
- (void)interruptOccurredAt:(int)localNum;
- (void)otherOccurred:(int)id;

@end	/* IODirectDevice */
